#version 460

#include "/lib/settings.glsl"

#ifdef FXAA
#endif

#ifdef SHARPEN
#endif

#if FOG
	uniform int isEyeInWater;
	uniform float blindness, rainStrength, far;

	out float fogStrength;
#endif

in vec3 vaPosition;
in vec2 vaUV0;
uniform mat4 projectionMatrix;

out vec2 texCoord;

#ifdef AUTOMATIC_EXPOSURE
	const float eyeBrightnessHalflife = 2.5; // [0.0 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 4.5 5.0 5.5 6.0 6.5 7.0 7.5 8.0 8.5 9.0 9.5 10.0]

	uniform ivec2 eyeBrightnessSmooth;

	uniform int worldTime;

	out float autoExposure;
#endif

void main() {
	gl_Position = projectionMatrix * vec4(vaPosition, 1.0);

	texCoord = vaUV0;

	#if FOG
		fogStrength = 0.2 * (FOG * 0.1 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / (far * far * far);
	#endif

	#ifdef AUTOMATIC_EXPOSURE
		float torchLight = eyeBrightnessSmooth.s;
		torchLight /= 30.0;

		float skyLight = eyeBrightnessSmooth.t;
		skyLight /= 240.0;
		skyLight += 0.5 - distance(worldTime, 6000.0) / 12000.0;

		autoExposure = max(1.0, 3.0 - mix(torchLight, 2.0, clamp(skyLight, 0.0, 1.0)));
	#endif
}