#version 460

#include "/lib/settings.glsl"

#if FOG
	uniform int isEyeInWater;
	uniform float blindness, rainStrength, far;

	out float fogStrength;
#endif

in vec3 vaPosition;
in vec2 vaUV0;
uniform mat4 projectionMatrix;

out vec2 texCoord;

void main() {
	gl_Position = projectionMatrix * vec4(vaPosition, 1.0);

	texCoord = vaUV0;

	#if FOG
		fogStrength = 0.2 * (FOG * 0.1 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / (far * far * far);
	#endif
}