#version 460

#include "/lib/settings.glsl"

out vec4 tintColor;

in vec3 vaPosition;
in vec4 vaColor;
uniform mat4 modelViewMatrix, projectionMatrix;

uniform vec3 fogColor;
uniform int isEyeInWater;
uniform float rainStrength, blindness, far, near;

void main() {
	vec4 position = projectionMatrix * modelViewMatrix * vec4(vaPosition, 1.0);

	gl_Position = position;

	float depth = position.z / position.w;
	float linearDepth = 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));

	float fogStrength = 0.1 * (FOG * 0.1 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / (far * far * far);
	float fogDistance = 25.0 + linearDepth;
	float fog = clamp(fogDistance * fogDistance * fogDistance * fogDistance * fogStrength, 0.0, 1.0);

	tintColor = vec4(vaColor.rgb + pow(fogColor, vec3(2.4)), vaColor.a * min(linearDepth * 0.01, 1.0 - fog));
}