#version 460

#include "/lib/settings.glsl"

layout(location = 0) out vec4 outColor0;

uniform sampler2D gtexture, lightmap;

#ifdef MC_SPECULAR_MAP
	#ifdef EMISSIVE_MAP
		uniform sampler2D specular;
	#endif
#endif

#ifndef NO_SHADOWS
	/* RENDERTARGETS: 0,2 */

	layout(location = 1) out vec4 outColor1;

	in vec3 normal;
#endif

in vec4 tintColor;
in vec2 texCoord;

uniform vec4 entityColor;

#ifndef HIGHLIGHT_ENTITIES
	in vec2 lmcoord;
#endif

void main() {
	vec4 color = texture(gtexture, texCoord) * tintColor;
	if (color.a < 0.1) discard;

	color.rgb = mix(color.rgb, entityColor.rgb, entityColor.a);

	#ifndef HIGHLIGHT_ENTITIES
		const float emission = 0.0;

		#include "/lib/light.glsl"
	#endif

	outColor0 = color;

	#ifndef NO_SHADOWS
		outColor1 = vec4(normal, 1.0);
	#endif
}