#version 460

#include "/lib/settings.glsl"

in vec3 vaPosition, vaNormal;
in vec4 vaColor;
in vec2 vaUV0;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform mat3 normalMatrix;
uniform vec3 chunkOffset;

out vec4 tintColor;
out vec2 texCoord;

#ifndef NO_SHADOWS
	out vec3 normal;
#endif

void main() {
	vec4 position = projectionMatrix * modelViewMatrix * vec4(vaPosition + chunkOffset, 1.0);

	gl_Position = position;
	texCoord = vaUV0;
	tintColor = vaColor;

	#ifndef NO_SHADOWS
		normal = normalize(normalMatrix * vaNormal) * 0.5 + 0.5;
	#endif
}