#version 460

#include "/lib/settings.glsl"

layout(location = 0) out vec4 outColor0;

uniform sampler2D gtexture, lightmap;

#ifdef MC_SPECULAR_MAP
	#ifdef EMISSIVE_MAP
		uniform sampler2D specular;
	#endif
#endif

in vec4 tintColor;

in vec2 texCoord, lmcoord;

in float emission;

void main() {
	vec4 color = texture(gtexture, texCoord) * tintColor;
	if (color.a < 0.1) discard;

	#include "/lib/light.glsl"

	outColor0 = color;
}