#version 460

#include "/lib/settings.glsl"

const mat4 TEXTURE_MATRIX_2 = mat4(vec4(0.00390625, 0.0, 0.0, 0.0), vec4(0.0, 0.00390625, 0.0, 0.0), vec4(0.0, 0.0, 0.00390625, 0.0), vec4(0.03125, 0.03125, 0.03125, 1.0));
in vec3 vaPosition;
in vec4 vaColor;
in vec2 vaUV0;
in ivec2 vaUV2;
uniform mat4 projectionMatrix;

out vec4 tintColor;
out vec2 texCoord, lmcoord;

out float emission;

uniform int heldItemId, heldItemId2, heldBlockLightValue, heldBlockLightValue2;

float getEmission() {
	if ((heldItemId + heldItemId2) / 2 == 1) {
		return 15.0;
	} else {
		return 0.0;
	}
}

float getIsRedstoneBlock() {
	#ifdef GLOWING_REDSTONE_BLOCK
		if (heldItemId == 2 || heldItemId2 == 2) {
			return 15.0;
		} else {
			return 0.0;
		}
	#else
		return 0.0;
	#endif
}

float getIsEmeraldBlock() {
	#ifdef GLOWING_EMERALD_BLOCK
		if (heldItemId == 3 || heldItemId2 == 3) {
			return 15.0;
		} else {
			return 0.0;
		}
	#else
		return 0.0;
	#endif
}

float getIsLapisBlock() {
	#ifdef GLOWING_LAPIS_BLOCK
		if (heldItemId == 4 || heldItemId2 == 4) {
			return 15.0;
		} else {
			return 0.0;
		}
	#else
		return 0.0;
	#endif
}

void main() {
	gl_Position = projectionMatrix * vec4(vaPosition, 1.0);
	texCoord = vaUV0;
	tintColor = vaColor;
	lmcoord = (TEXTURE_MATRIX_2 * vec4(vaUV2, 0.0, 1.0)).xy;

	emission = min((heldBlockLightValue + heldBlockLightValue2 + getEmission() + getIsRedstoneBlock() + getIsEmeraldBlock() + getIsLapisBlock()) / 15.0, 1.0);
}