vec4 distort(in vec4 shadowPosition) {
	const float bias0 = 0.95;
	const float bias1 = 1.0 - bias0;

	float factorDistance = sqrt(shadowPosition.x * shadowPosition.x + shadowPosition.y * shadowPosition.y);

	float distortFactor = factorDistance * bias0 + bias1;

	shadowPosition.xyz *= vec3(vec2(1.0 / distortFactor), 0.2);

	return shadowPosition;
}