#if defined EMISSIVE_MAP && defined MC_SPECULAR_MAP
	const float clampEmissive = 244.0;

	float emissiveMap = texture(specular, texCoord).EMISSIVE_CHANNEL;

	emissiveMap = mix(emissiveMap, 0.0, step(clampEmissive, emissiveMap * 255.0));
#else
	const float emissiveMap = 0.0;
#endif

//vec3 light = vec3(1.0) - min(pow(vec3(1.0) - texture(lightmap, lmcoord).rgb, vec3(4.0)), vec3(1));
vec3 light = texture(lightmap, lmcoord).rgb;

#if EMISSIVE_COLOR == 0
	vec3 maxLight = texture(lightmap, vec2(1.0, -1.0)).rgb;
#else
	const vec3 maxLight = vec3(EMISSIVE_COLOR);
#endif

color.rgb *= mix(light, maxLight, clamp(emission + emissiveMap, 0.0, 1.0));