#version 460

#include "/lib/settings.glsl"

#ifdef TERRAIN_SHADOWS
#endif

#ifdef ENTITY_SHADOWS
#endif

#ifdef BLOCK_ENTITY_SHADOWS
#endif

#ifdef COLORED_SHADOWS
	layout(location = 0) out vec3 outColor0;

	in vec4 tintColor;
#else
	in float tintColor;
#endif

uniform sampler2D gtexture;

in vec2 texCoord;

void main() {
	#if defined COLORED_SHADOWS
		vec4 color = texture(gtexture, texCoord) * tintColor;
		if (color.a < 0.2) {
			discard;
		} else if (color.a < 0.9) {
			outColor0 = color.rgb * 3.0; // 4.0 * (1.0 - color.a); // Makes more sense but looks worse imo
		} // just doing nothing here is the same as else {outColor0 = vec3(0.0);}

		/* Old shadows from v1.1 - Kinda look like subsurface scattering
			vec4 color = texture(gtexture, texCoord) * tintColor;
			if (color.a < 0.1) discard;

			outColor0 = color.rgb * 3.0;
		*/
	#else
		if (texture(gtexture, texCoord).a * tintColor < 0.2) discard;
	#endif
}