#version 460

#include "/lib/settings.glsl"

#include "/lib/distort.glsl"

in vec3 vaPosition;
in vec4 vaColor;
in vec2 vaUV0;
uniform mat4 modelViewMatrix, projectionMatrix; // textureMatrix
uniform vec3 chunkOffset;

#ifdef COLORED_SHADOWS
	out vec4 tintColor;
#else
	out float tintColor;
#endif

out vec2 texCoord;

void main() {
	gl_Position = distort(projectionMatrix * modelViewMatrix * vec4(vaPosition + chunkOffset, 1.0));

	texCoord = vaUV0; // (textureMatrix * vec4(vaUV0, 0.0, 1.0)).xy;

	#ifdef COLORED_SHADOWS
		tintColor = vaColor;
	#else
		tintColor = vaColor.a;
	#endif
}